#!/usr/bin/python
# coding: utf-8

#--------------------------------------------------------------------
# Fichero:  fn-actualiza-basedato.py
# Objetivo: Actualizar la base de datos de 5.0 a 6.0
# Autor:    Pedro Reina <pedro@pedroreina.net>
# Fecha:    D.3.1.2016
# Licencia: Dominio público
#--------------------------------------------------------------------

#------------------------------------------------
# Variables del programa
#------------------------------------------------

# El archivo con la base de datos
BaseDato = "fn.db"

#------------------------------------------------
# Módulos necesarios
#------------------------------------------------

# Another Python SQLite Wrapper
import apsw

#------------------------------------------------
# Variables globales
#------------------------------------------------

ListaSerie = []

#------------------------------------------------
# Funciones
#------------------------------------------------

#------------------------------------------------
# Lee la base de datos y la convierte en una lista
def LeeDatos (Conexion):
  global ListaSerie
  Consulta = "SELECT rowid, cast(descripcion AS blob) FROM serie"
  Cursor = Conexion.cursor()
  for Serie in Cursor.execute (Consulta):
    ListaSerie.append (Serie)

#------------------------------------------------
# Convierte las descripciones y las escribe en la base de datos
def EscribeDatos (Conexion):
  Consulta = "UPDATE serie SET descripcion=:Descripcion WHERE rowid=:Rowid"
  Cursor = Conexion.cursor()

  for Serie in ListaSerie:
    Rowid = Serie[0]
    Anterior = str(Serie[1])
    Anterior = Anterior.decode('iso-8859-1').encode('utf8')
    Descripcion = unicode (Anterior, 'utf-8')
    Cursor.execute (Consulta, locals())

#------------------------------------------------
# Optimiza la base de datos
def Optimiza (Conexion):
  Consulta = "VACUUM"
  Cursor = Conexion.cursor()
  Cursor.execute (Consulta)

#------------------------------------------------
# El programa
#------------------------------------------------

# Informamos al usuario
print "Conversión de la base de datos"
print "=============================="
print
print "Base de datos: " + BaseDato

# Abrimos conexión a la base de datos
Conexion = apsw.Connection (BaseDato)

# Lectura
print "Leyendo datos..."
LeeDatos (Conexion)

# Escritura
print "Escribiendo datos..."
EscribeDatos (Conexion)

# Optimización de la base de datos
print ("Optimizando la base de datos..."),
Optimiza (Conexion)

# Cerramos la conexión
Conexion.close (True)

# Hemos acabado; informamos al usuario
print "Terminado."
