#!/bin/sh

#--------------------------------------------------------------------
# Fichero:  fn-actualiza-servir.sh
# Objetivo: Instalar los archivos necesarios para servir las fotos
#           y preparar los archivos auxiliares en una instalación
#           de fn 5.0 que se está actualizando a 6.0
# Autor:    Pedro Reina <pedro@pedroreina.net>
# Fecha:    D.3.1.2016
# Ejemplo:  fn-actualiza-servir /home/web
#--------------------------------------------------------------------

# Comprobamos si nos han mandado un argumento
if [ $# -lt 1 ]; then
   echo "Este programa necesita un parámetro, el DocumentRoot"

else
  # Directorio DocumentRoot del servidor web
  DocumentRoot=$1

  # Informamos al usuario
  echo -n Actualizando...

  # Eliminamos la documentación anterior
  rm $DocumentRoot/fotos/doc/*

  # Reservamos la configuración anterior
  cp $DocumentRoot/fotos/config.php $DocumentRoot/fotos/config.php.seg

  # Copiamos los archivos
  cp servir/*.php $DocumentRoot/fotos/
  cp servir/*.css $DocumentRoot/fotos/
  cp servir/*.js $DocumentRoot/fotos/
  cp servir/imagen/* $DocumentRoot/fotos/imagen
  cp doc/* $DocumentRoot/fotos/doc/

  # Informamos al usuario
  echo " hecho."
  echo "El administrador del sistema debe borrar /usr/local/bin/fn-coloca.pl"
fi
