#!/bin/sh

#--------------------------------------------------------------------
# Fichero:  fn-instala-servir.sh
# Objetivo: Instalar los archivos necesarios para servir las fotos
#           y preparar los archivos auxiliares
# Autor:    Pedro Reina <pedro@pedroreina.net>
# Fecha:    S.2.1.2016
# Ejemplo:  fn-instala-servir /home/web
#--------------------------------------------------------------------

# Comprobamos si nos han mandado un argumento
if [ $# -lt 1 ]; then
   echo "Este programa necesita un parámetro, el DocumentRoot"

else
  # Directorio DocumentRoot del servidor web
  DocumentRoot=$1

  # Informamos al usuario
  echo -n Instalando...

  # Creamos los directorios
  mkdir $DocumentRoot/fotos
  mkdir $DocumentRoot/fotos/imagen
  mkdir $DocumentRoot/fotos/doc
  mkdir $DocumentRoot/fotos/indices
  mkdir $DocumentRoot/fotos/carga

  # Copiamos los archivos
  cp servir/*.php $DocumentRoot/fotos/
  cp servir/*.css $DocumentRoot/fotos/
  cp servir/*.js $DocumentRoot/fotos/
  cp servir/fn.db $DocumentRoot/fotos/
  cp servir/fn.htaccess $DocumentRoot/fotos/.htaccess
  cp servir/imagen/* $DocumentRoot/fotos/imagen
  cp doc/* $DocumentRoot/fotos/doc/

  # Informamos al usuario
  echo " hecho."
fi
