#!/usr/bin/python
# coding: utf-8

#--------------------------------------------------------------------
# Fichero:  fn-numera.py
# Objetivo: Numerar las fotos de un directorio
# Autor:    Pedro Reina <pedro@pedroreina.net>
# Fecha:    D.6.9.2015
# Licencia: Dominio público
#--------------------------------------------------------------------

#------------------------------------------------
# Constantes del programa
#------------------------------------------------

#------------------------------------------------
# Módulos necesarios
#------------------------------------------------

# Para leer la línea de órdenes
import sys

# Para leer el contenido de un directorio
# Para renombrar archivos
import os

# Para manejar expresiones regulares
import re

#------------------------------------------------
# Variables globales
#------------------------------------------------

#------------------------------------------------
# Funciones
#------------------------------------------------

#------------------------------------------------
# Prepara un nombre de archivo
def PreparaNombre (Num):
  return '%04d' % Num + '.jpg'

#------------------------------------------------
# El programa
#------------------------------------------------

# Informamos al usuario
print "fn-numera.py"
print "============"

# Si no hay dos argumentos, ayuda al usuario
if ( len(sys.argv) < 3 ):
  print "Es necesario indicar el primer número y 'r'(ealizar) o 's'(imular)"

# Si nos mandan dos argumentos, son el primer número y la orden
else:
  Primero = (int)(sys.argv[1])
  Orden = sys.argv[2]

  # Obtenemos la lista de archivos del directorio
  ListaArchivos = os.listdir ('.')

  # La lista con las imágenes que encontremos
  ListaImagenes = []

  # Recorremos la lista buscando archivos JPG
  ExpresionRegular = re.compile ('\.jpg$', re.IGNORECASE)
  for Archivo in ListaArchivos:
    if ( ExpresionRegular.search (Archivo) ):
      ListaImagenes.append (Archivo)

  # Informamos de cuántos archivos hemos encontrado
  TotalImagen = len (ListaImagenes)
  print "El directorio contiene " + str(TotalImagen) + " imágenes"

  if ( TotalImagen > 0 ):
    # Ordenamos la lista
    ListaImagenes.sort()

    # Informamos de lo que hacemos
    if ( Orden == 'r' ):
      print "Modo real de numeración de fotos"
    else:
      print "Modo simulación"

    # Para cada imagen encontrada
    i = Primero
    for Archivo in ListaImagenes:
      # Buscamos un nombre para el nuevo archivo
      Nuevo = PreparaNombre (i)

      # Renombramos el archivo
      print Archivo + ' => ' + Nuevo
      if ( Orden == 'r' ):
        os.rename (Archivo, Nuevo)
      i += 1

# Hemos acabado; informamos al usuario
print "Terminado."
