//--------------------------------------------------------------
// Fichero:  admin.js
// Objetivo: Rutinas JavaScript de apoyo para ver los índices
// Autor:    Pedro Reina
// Fecha:    L.25.8.2014
// Licencia: Dominio público
//--------------------------------------------------------------

//---------------------------------
// Constantes
//---------------------------------

//---------------------------------
// Variables globales
//---------------------------------

// Identificadores
var DivIndice;

// Directorio de las fotos
var DirIndice = "./indices/";

//---------------------------------
// Funciones
//---------------------------------

//--------------------------------------------------------------
// Si ponen el puntero sobre el icono hay que mostrar el indice
function PunteroEnIconoIndice (Evento)
  {
  // Tomamos el ID del evento que ha disparado esta función
  var Id = Evento.target.id;

  // Cambiamos el puntero
  document.body.style.cursor = 'help';

  // Anotamos la URL del indice
  DivIndice.innerHTML =
    '<IMG SRC="' + DirIndice + Id + '.jpg" CLASS="indice">';
  }

//--------------------------------------------------------------
// Si quitan el puntero del icono hay que quitar el indice
function PunteroFueraIconoIndice()
  {
  DivIndice.innerHTML = '';
  document.body.style.cursor = 'default';
  }

//--------------------------------------------------------------
// Función portable que añade un evento
function AgregaEvento (elemento, evType, funcion, useCapture)
  {
  // Manejador de eventos compatible con navegadores IE5+, NS6 y Mozilla
  // Autor: Scott Andrew
  if ( elemento.addEventListener )
    {
    elemento.addEventListener (evType, funcion, useCapture);
    return true;
    }
  else if ( elemento.attachEvent )
    {
    var r = elemento.attachEvent ('on' + evType, funcion);
    return r;
    }
  else
    { elemento ['on' + evType] = funcion; }
  }

//--------------------------------------------------------------
// La función que inicia todo el sistema
function IniciaTodo()
  {
  // Averiguamos los ID de los elementos
  var TodosLosTags = document.body.getElementsByTagName ('*');
  var Identificadores = [];
  for (var i = 0 ; i < TodosLosTags.length; i++)
    {
    var Tag = TodosLosTags[i];
    if (Tag.id)
      { Identificadores.push (Tag.id); }
    }

  // Averiguamos el DIV del índice
  DivIndice = document.getElementById ('indice');

  // Añadimos todos los "listeners" de los índices
  for (var i = 0 ; i < Identificadores.length; i++)
    {
    Elemento = document.getElementById (Identificadores[i]);
    AgregaEvento (Elemento, 'mouseover', PunteroEnIconoIndice, false);
    AgregaEvento (Elemento, 'mouseout', PunteroFueraIconoIndice, false);
    }
  }

//--------------------------------------------------------------
// La función que inicia el sistema cuando se carga la página
AgregaEvento (window, 'load', IniciaTodo, false);
