<?php

//--------------------------------------------------------------
// Fichero:  admin.php
// Objetivo: Administrar las series de fotos
// Fecha:    D.3.1.2016
// Autor:    Pedro Reina
// Licencia: Dominio público
//--------------------------------------------------------------

//--------------------------------------------------------------
// Los archivos comunes del sistema
//--------------------------------------------------------------

require_once "config.php";
require_once "fn.php";

//--------------------------------------------------------------
// La contraseña de administración
//--------------------------------------------------------------

require_once "contrasena.php";
require_once "password.php";

//--------------------------------------------------------------
// Programa principal
//--------------------------------------------------------------

// Arrancamos el sistema de sesiones de PHP
session_start();

// Miramos si el usuario se ha identificado
if ( isset ($_SESSION['Dentro']) )
  { $Dentro = $_SESSION['Dentro']; }
else
  { $Dentro = FALSE; }

// Si no se ha identificado, pedimos o comprobamos la contraseña
if ( ! $Dentro )
  {
  // Si acabamos de cargar la página, hay que pedir la contraseña
  if ( ! isset ($_POST['cs']) )
    { MuestraFormulario(); }

  // Si ya han escrito la contraseña, la comprobamos
  else
    {
    // Si la contraseña es correcta, dejamos pasar
    if ( password_verify ($_POST['cs'], $Contrasena) )
      { $_SESSION['Dentro'] = TRUE; }

    // Recargamos la página
    header ('location: ' . $_SERVER['PHP_SELF']);
    }
  }

// Si estamos dentro, vemos qué nos han pedido
else
  {
  if ( isset ($_GET['Orden']) )
    {
    $Orden = $_GET['Orden'];
    if ( strcmp ($Orden, "Terminar") == 0 )
      { TerminaAdministracion(); }
    if ( strcmp ($Orden, "Listar") == 0 )
      { ListadoSeries(); }
    if ( strcmp ($Orden, "Editar") == 0 )
      { EditaSerie(); }
    if ( strcmp ($Orden, "Cargar") == 0 )
      { CargaSerie(); }
    if ( strcmp ($Orden, "Foto") == 0 )
      { EditaFoto(); }
    }

  if ( isset ($_POST['Modificar']) )
    { 
    $Modificar = $_POST['Modificar'];
    ModificaSerie ($Modificar); 
    }

  if ( isset ($_POST['Insertar']) )
    { InsertaSerie(); }

  if ( isset ($_POST['Grabar']) )
    { GrabaComentario(); }

  // Si hemos llegado hasta aquí, es la primera página que vemos
  // tras la autentificación
  if ( ! isset ($Orden) AND ! isset ($_POST['Modificar']) AND
       ! isset ($_POST['Insertar']) AND ! isset ($_POST['Grabar']) )
    { ComienzaPagina(); }

  // Mostramos opciones de administración
  MuestraOpciones();
  }

//--------------------------------------------------------------
// Funciones
//--------------------------------------------------------------

// ----------------------------------------------
// Rutina para comenzar la página
function ComienzaPagina()
  {
  FN_EmiteDTD();
  print "<HTML>\n";
  FN_EmiteCabecera ("Administración de Fotos digitales", "admin.js");
  print "<BODY>\n";
  FN_EmiteLogotipo();
  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo1\">Administración de fotos digitales</DIV>\n";
  print "</DIV>\n";
  }

// ----------------------------------------------
// Rutina para terminar la página
function TerminaPagina()
  {
  print "</BODY>\n";
  print "</HTML>\n";
  }

// ----------------------------------------------
// Rutina para mostrar el formulario de entrada
function MuestraFormulario()
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  ComienzaPagina();

  // Emitimos el formulario
  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Contraseña de administración</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";
  print "<FORM ACTION=\"$YoMismo\" METHOD=\"POST\">\n";
  print "<P CLASS=\"centrado\">\n";
  print "<INPUT TYPE=\"PASSWORD\" NAME=\"cs\">\n";
  print "&nbsp;&nbsp;";
  print "<INPUT TYPE=\"SUBMIT\" NAME=\"Entrar\" VALUE=\" Entrar \">\n";
  print "</FORM>\n";
  print "  </DIV>\n";
  print "</DIV>\n";

  TerminaPagina();
  }

// ----------------------------------------------
// Rutina para mostrar las opciones de administración
function MuestraOpciones()
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  // Emitimos las opciones
  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Opciones de administración</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";
  print "  <P CLASS=\"centrado\">\n";
  print "  <A CLASS=\"menu\" HREF=\"$YoMismo\">Refrescar</A>\n";
  print "  <A CLASS=\"menu\" HREF=\"$YoMismo?Orden=Cargar\">Cargar</A>\n";
  print "  <A CLASS=\"menu\" HREF=\"$YoMismo?Orden=Listar\">Listar</A>\n";
  print "  <A CLASS=\"menu\" HREF=\"$YoMismo?Orden=Terminar\">Terminar</A>\n";
  print "</DIV>\n";
  print "</DIV>\n";

  TerminaPagina();
  }

// ----------------------------------------------
// Rutina para dar un listado de todas las series
function ListadoSeries()
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  ComienzaPagina();

  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Listado de todas las series</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";
  print "  <TABLE BORDER=\"1\" CELLPADDING=\"3\">\n";
  print "  <TR>\n";
  print "  <TD>Orden</TD>\n";
  print "  <TD>Nombre</TD>\n";
  print "  <TD>Descripción</TD>\n";
  print "  <TD>Visible</TD>\n";
  print "  <TD>Cantidad</TD>\n";
  print "  <TD>Editar</TD>\n";
  print "  <TD>Ver</TD>\n";
  print "  </TR>\n";

  // Consultamos los datos de las series
  $Series = FN_ListaCompletaSeries();

  // Imprimimos las series obtenidas
  foreach ( $Series as $Serie )
    {
    // Asignamos los campos a variables, por comodidad
    $RowId = $Serie['rowid'];
    $Num = $Serie['num'];
    $Nombre = $Serie['nombre'];
    $Descripcion = $Serie['descripcion'];
    $Visible = $Serie['visible'];
    $Cantidad = $Serie['cantidad'];

    // Mostramos el registro
    print "  <TR>\n";
    print "  <TD>$Num</TD>\n";
    print "  <TD>$Nombre</TD>\n";
    print "  <TD>$Descripcion</TD>\n";
    print "  <TD>$Visible</TD>\n";
    print "  <TD>$Cantidad</TD>\n";
    print "  <TD><A CLASS=\"texto\" HREF=\"$YoMismo?Orden=Editar&amp;RowId=$RowId\">Editar</A></TD>\n";
    print "  <TD><IMG ID=\"$Nombre\" SRC=\"imagen/ver.png\" CLASS=\"ver\"></TD>\n";
    print "  </TR>\n";
    }

  print "  </TABLE>\n";
  print "</DIV>\n";
  print "</DIV>\n";

  // La zona donde va el índice de cada serie
  print "<DIV ID=\"indice\" CLASS=\"indice\"></DIV>\n";
  }

// ----------------------------------------------
// Rutina para editar los datos de una serie
function EditaSerie()
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  $RowId = $_GET['RowId'];

  // Obtenemos los datos de la serie
  $Registro = FN_DatosSerie ($RowId);

  // Asignamos los campos a variables, por comodidad
  $Num = $Registro['num'];
  $Nombre = $Registro['nombre'];
  $Descripcion = $Registro['descripcion'];
  $Visible = $Registro['visible'];
  $Cantidad = $Registro['cantidad'];

  // La imagen índice
  $Indice = "indices/$Nombre.jpg";

  ComienzaPagina();

  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Edición de una serie</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";

  // Imprimimos un formulario con los datos
  $CodigoHTML=<<<HTML

  <FORM ACTION="$YoMismo" METHOD="POST">
    <INPUT TYPE="HIDDEN" NAME="Modificar" VALUE="$RowId">
    <P>Número: <INPUT TYPE="TEXT" NAME="Num" VALUE="$Num">
    <P>Nombre: <INPUT TYPE="TEXT" NAME="Nombre" VALUE="$Nombre">
    <P>Descripción:
    <P><TEXTAREA COLS="70" ROWS="5"
        NAME="Descripcion" WRAP="virtual">$Descripcion</TEXTAREA>
    <P>Visible: <INPUT TYPE="TEXT" NAME="Visible" VALUE="$Visible">
    <P>Cantidad: <INPUT TYPE="TEXT" NAME="Cantidad" VALUE="$Cantidad">
    <P><INPUT TYPE="SUBMIT" NAME="Ejecutar" VALUE=" Modificar ">
  </FORM>

HTML;
  print $CodigoHTML;

  // Mostramos el índice con un mapa
  FN_EmiteIndiceMapa ($Nombre, 'PreparaEnlaceFoto');

  print "</DIV>\n";
  print "</DIV>\n";
  }

//--------------------------------------------------------------
// Prepara un enlace para editar una foto
function PreparaEnlaceFoto ($Serie, $Numero)
  {
  $YoMismo = $_SERVER['PHP_SELF'];
  return ("$YoMismo?Orden=Foto&amp;Serie=$Serie&amp;Numero=$Numero");
  }

// ----------------------------------------------
// Rutina para modificar los datos de una serie
function ModificaSerie ($RowId)
  {
  // Recibimos los valores del formulario
  $Num = $_POST['Num'];
  $Nombre = $_POST['Nombre'];
  $Descripcion = $_POST['Descripcion'];
  // El navegador escapa las comillas, así que las desescapo
  $Descripcion = str_replace ('\\', '', $Descripcion);
  $Visible = $_POST['Visible'];
  $Cantidad = $_POST['Cantidad'];

  // La imagen índice
  $Indice = "indices/$Nombre.jpg";

  // Imprimimos los datos
  ComienzaPagina();
  print "<DIV CLASS=\"cuadro\">\n";
  print "<DIV CLASS=\"titulo2\">Nuevos datos de la serie</DIV>\n";
  print "<DIV CLASS=\"contenido\">\n";
  print "<P>Número de orden: $Num\n";
  print "<P>Nombre: $Nombre\n";
  print "<P>Descripción: $Descripcion\n";
  print "<P>Visible: $Visible\n";
  print "<P>Cantidad: $Cantidad\n";
  print "<P><IMG SRC=\"$Indice\">\n";
  print "</DIV>\n";
  print "</DIV>\n";
  TerminaPagina();

  // Actualizamos la base de datos
  FN_ActualizaSerie ($Num, $Nombre, $Descripcion, $Visible, $RowId);
  }

// ----------------------------------------------
// Rutina para editar el comentario de una foto
function EditaFoto()
  {
  // Nos pasan datos por la URL
  $Serie = $_GET['Serie'];
  $Numero = $_GET['Numero'];

  // Llamamos a la función que va mostrar la foto
  MuestraFoto ($Serie, $Numero);
  }

// ----------------------------------------------
// Mostramos una foto con su comentario para editarlo
function MuestraFoto ($Serie, $Numero)
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  // Obtenemos el RowId de la serie
  $RowId = FN_RowIdSerie ($Serie);

  // Montamos una relación con los nombres de las fotos
  // que hay en el directorio de la serie
  $Relacion = FN_Relacion ($Serie);

  // Nombre del archivo con la foto
  $NombreArchivo = $Relacion[$Numero-1];

  // Dimensiones de la imagen pedida
  $TamanoImagen = GetImageSize ("$Serie/reducidas/$NombreArchivo.jpeg");

  // Las dimensiones las lee PHP
  $DimensionesImagen = $TamanoImagen[3];

  // Calculamos las fotos anterior y siguiente
  $Anterior = $Numero - 1;
  if ( $Anterior == 0 )
    { $Anterior = 1; }
  $Siguiente = $Numero + 1;
  if ( $Siguiente == count ($Relacion)+1 )
    { $Siguiente = count ($Relacion); }

  // Los enlaces al índice, a las fotos anterior y siguiente y a grabar
  $EnlaceIndice = "$YoMismo?Orden=Editar&amp;RowId=$RowId";
  $Anterior = $Numero - 1;
  if ( $Anterior == 0 )
    { $EnlaceAnterior = $EnlaceIndice; }
  else
    { $EnlaceAnterior = PreparaEnlaceFoto ($Serie, $Anterior); }
  $Siguiente = $Numero + 1;
  if ( $Siguiente == count ($Relacion)+1 )
    { $EnlaceSiguiente = $EnlaceIndice; }
  else
    { $EnlaceSiguiente = PreparaEnlaceFoto ($Serie, $Siguiente); }

  // Leemos el comentario
  $Comentario = FN_LeeComentario ($Serie, $NombreArchivo);

  ComienzaPagina();

  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Edición de una foto</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";

  // Los datos de la foto
  print "<P CLASS=\"centrado\">Nombre de la serie: $Serie | \n";
  print "Número de la foto: $Numero | \n";
  print "Archivo: $NombreArchivo.jpeg\n";

  // La imagen mediana con un vínculo a la grande
  print "<P CLASS=\"centrado\">\n";
  print "<A HREF=\"$Serie/$NombreArchivo.jpg\">\n";
  print "<IMG SRC=\"$Serie/reducidas/$NombreArchivo.jpeg\" " .
        "$DimensionesImagen></A>\n";

  // Podemos modificar el comentario
  print "<FORM ACTION=\"$YoMismo\" METHOD=\"POST\">\n";
  print "<P CLASS=\"centrado\">\n";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"Serie\" VALUE=\"$Serie\">\n";
  print "<INPUT TYPE=\"HIDDEN\" NAME=\"Numero\" VALUE=\"$Numero\">\n";
  print "<TEXTAREA COLS=\"70\" ROWS=\"5\" NAME=\"Comentario\" " .
        "WRAP=\"virtual\">$Comentario</TEXTAREA>\n";
  print "<P CLASS=\"centrado\">\n";
  print "<INPUT TYPE=\"SUBMIT\" NAME=\"Grabar\" VALUE=\" Grabar \">\n";
  print "</FORM>\n";

  print "</DIV>\n";
  print "</DIV>\n";

  // Emitimos las opciones para gestionar la foto
  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Opciones para la foto</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";
  print "  <P CLASS=\"centrado\">\n";
  print "  <A CLASS=\"menu\" HREF=\"$EnlaceAnterior\">Anterior</A>\n";
  print "  <A CLASS=\"menu\" HREF=\"$EnlaceIndice\">Índice</A>\n";
  print "  <A CLASS=\"menu\" HREF=\"$EnlaceSiguiente\">Siguiente</A>\n";
  print "</DIV>\n";
  print "</DIV>\n";
  }

// ----------------------------------------------
// Rutina para grabar el comentario de una foto
function GrabaComentario()
  {
  $YoMismo = $_SERVER['PHP_SELF'];

  // Nos pasan datos por la URL
  $Serie = $_POST['Serie'];
  $Numero = $_POST['Numero'];
  $Comentario = $_POST['Comentario'];

  // Montamos una relación con los nombres de las fotos
  // que hay en el directorio de la serie
  $Relacion = FN_Relacion ($Serie);

  // Nombre del archivo con la foto
  $NombreArchivo = $Relacion[$Numero-1];

  // Ruta completa al archivo
  $ArchivoReal = "$Serie/reducidas/$NombreArchivo.jpeg";

  // Copiamos la imagen a un archivo temporal
  copy ($ArchivoReal, "tmp");

  // La orden que añadirá el comentario a la imagen
  $Orden = "wrjpgcom -replace -comment '$Comentario' tmp > $ArchivoReal";

  // Ejecutamos la orden
  $ResultadoNoUsado = rtrim(`$Orden`);

  // Eliminamos el archivo temporal
  unlink ("tmp");

  // Volvemos a mostrar la foto
  MuestraFoto ($Serie, $Numero);
  }

// ----------------------------------------------
// Rutina para presentar una nueva serie al administrador
function CargaSerie()
  {
  global $DirCarga;
  $YoMismo = $_SERVER['PHP_SELF'];

  ComienzaPagina();

  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Carga de una nueva serie</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";

  // Averiguamos cuántas fotos tiene la serie
  $ListaMedianas = glob ($DirCarga . "/*.jpeg");
  $Cantidad = count ($ListaMedianas);

  // Si no hay fotos, informamos
  if ( $Cantidad == 0 )
    { print "No hay ninguna serie disponible para cargar\n"; }

  else
    {
    // Proponemos el número siguiente al máximo
    $Num = FN_MaxSerie() + 1;

    // Como nombre propondremos la fecha de las fotos
      // El archivo con la primera foto
      $PrimeraFoto = str_replace (".jpeg", ".jpg", $ListaMedianas[0]);

      // Sus metadatos
      $DatosExif = exif_read_data ($PrimeraFoto);

      // El momento en que se tomó la foto
      $FechaHora = $DatosExif['DateTime'];

      // La fecha
      $ArrayFechaHora = explode (' ', $FechaHora);
      $Fecha = $ArrayFechaHora[0];

      // El nombre
      $Nombre = str_replace (":", "-", $Fecha);

    // Proponemos que la serie sea visible
    $Visible = 1;

    // La imagen índice
    $Indice = $DirCarga . "/indice.jpg";

    // Imprimimos un formulario con los datos
    $CodigoHTML=<<<HTML

    <FORM ACTION="$YoMismo" METHOD="POST">
      <P>Número: <INPUT TYPE="TEXT" NAME="Num" VALUE="$Num">
      <P>Nombre: <INPUT TYPE="TEXT" NAME="Nombre" VALUE="$Nombre">
      <P>Descripción:
      <P><TEXTAREA COLS="70" ROWS="5"
          NAME="Descripcion" WRAP="virtual"></TEXTAREA>
      <P>Visible: <INPUT TYPE="TEXT" NAME="Visible" VALUE="$Visible">
      <P>Cantidad: <INPUT TYPE="TEXT" NAME="Cantidad" VALUE="$Cantidad">
      <P><INPUT TYPE="SUBMIT" NAME="Insertar" VALUE=" Insertar ">
    </FORM>

    <P><IMG SRC="$Indice">

HTML;
    print $CodigoHTML;
    }

  print "</DIV>\n";
  print "</DIV>\n";
  }

// ----------------------------------------------
// Rutina para insertar una serie
function InsertaSerie()
  {
  // Recibimos los valores del formulario
  $Num = $_POST['Num'];
  $Nombre = $_POST['Nombre'];
  $Descripcion = $_POST['Descripcion'];
  // El navegador escapa las comillas, así que las desescapo
  $Descripcion = str_replace ('\\', '', $Descripcion);
  $Visible = $_POST['Visible'];
  $Cantidad = $_POST['Cantidad'];

  ComienzaPagina();

  // Imprimimos los datos
  print "<DIV CLASS=\"cuadro\">\n";
  print "  <DIV CLASS=\"titulo2\">Datos de la nueva serie</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";

  print "<P>Número de orden: $Num\n";
  print "<P>Nombre: $Nombre\n";
  print "<P>Descripción: $Descripcion\n";
  print "<P>Visible: $Visible\n";
  print "<P>Cantidad: $Cantidad\n";

  print "</DIV>\n";
  print "</DIV>\n";

  TerminaPagina();

  // Realizamos la copia de archivos e insercion en la base de datos
  FN_InsertaSerie ($Num, $Nombre, $Descripcion, $Visible, $Cantidad);
  }

// ----------------------------------------------
// Rutina para terminar la administración
function TerminaAdministracion()
  {
  // Terminamos la sesión PHP
  $_SESSION = array();
  session_destroy();

  // Dirigimos el navegador a la página principal de fotos
  header ('location: ./');
  }

?>
