#!/usr/bin/php
<?php
//--------------------------------------------------------------
// Fichero:  fn-coloca.php
// Objetivo: Colocar una serie de fotos
// Autor:    Pedro Reina
// Fecha:    S.1.3.2014
// Licencia: Dominio público
// Ejemplo:  fn-coloca.php "Cumpleaños de varios amigos"
//--------------------------------------------------------------

// Archivos del sistema fn
require "config.php";
require "fn.php";

// Comprobamos que nos mandan un dato
if ( count ($argv) != 2 )
  { echo "Uso: " . $argv[0] . " 'Descripción de la serie'\n"; }

else
  {
  // Tomamos el dato de la línea de órdenes
  $Descripcion = $argv[1];

  // Averiguamos cuántas fotos tiene la serie
  $ListaMedianas = glob ($DirCarga . "/*.jpeg");
  $Cantidad = count ($ListaMedianas);

  // Si no hay fotos, informamos
  if ( $Cantidad == 0 )
    { print "No hay ninguna serie disponible para cargar\n"; }

  else
    {
    // El número de la serie será el siguiente al máximo
    $Num = FN_MaxSerie() + 1;

    // Como nombre usaremos la fecha de la primera foto
      // El archivo con la primera foto
      $PrimeraFoto = str_replace (".jpeg", ".jpg", $ListaMedianas[0]);

      // Sus metadatos
      $DatosExif = exif_read_data ($PrimeraFoto);

      // El momento en que se tomó la foto
      $FechaHora = $DatosExif['DateTime'];

      // La fecha
      $ArrayFechaHora = explode (' ', $FechaHora);
      $Fecha = $ArrayFechaHora[0];

      // El nombre
      $Nombre = str_replace (":", "-", $Fecha);

    // La serie será visible por defecto
    $Visible = 1;

    // Informamos de los datos de la serie
    print "Serie: $Nombre; cantidad: $Cantidad\n";

    // Añadimos la serie
    FN_InsertaSerie ($Num, $Nombre, $Descripcion, $Visible, $Cantidad);
    }

  // Hemos terminado
  print "Terminado\n";
  }
?>
