<?php

//--------------------------------------------------------------
// Fichero:  fotos/index.php
// Objetivo: Página principal de Fotos digitales
// Fecha:    L.4.1.2016
// Autor:    Pedro Reina
// Licencia: Dominio público
//--------------------------------------------------------------

//------------------------------------------------
// Ficheros necesarios
//------------------------------------------------

require_once "config.php";
require_once "fn.php";

//------------------------------------------------
// Comienzo de la página
//------------------------------------------------

FN_EmiteDTD();

print "<HTML>\n";

FN_EmiteCabecera ("Fotos digitales");

print "<BODY>\n";

FN_EmiteLogotipo();

//------------------------------------------------
// Presentación
//------------------------------------------------

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo1\">Fotos digitales</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
print $Presentacion;
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Series
//------------------------------------------------

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo2\">Series</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
EmiteSeries();
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Estadística
//------------------------------------------------

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo2\">Estadística</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
EmiteEstadistica();
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Notas técnicas
//------------------------------------------------

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo3\">Notas técnicas</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
print "El programa que permite preparar y mostrar las fotografías es \n";
print "<A CLASS=\"texto\" HREF=\"http://pedroreina.net/desarrollos/fn/\">fn</A>\n";
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Posibilidades para seguir
//------------------------------------------------

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo3\">Posibilidades para seguir</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
print "  <A CLASS=\"texto\" HREF=\"/\">Volver a la página principal</A>\n";
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Final de la página
//------------------------------------------------

FN_EmiteValidadores();

print "</BODY>\n";
print "</HTML>\n";

//------------------------------------------------
// Funciones
//------------------------------------------------

//------------------------------------------------
// Emite las series de fotos
function EmiteSeries()
  {
  // Consultamos cuántas series hay
  $TotalSerie = FN_TotalSerie();

  if ( $TotalSerie == 0 )
    { print "Todavía no hay ninguna serie\n"; }

  else
    {
    // Consultamos los nombres y descripciones de las series
    $Series = FN_ListaSeries();

    // Imprimimos una lista
    print "<UL>\n";

    // Para cada serie de fotos
    foreach ( $Series as $Serie )
      {
      // Asignamos los campos a variables, por comodidad
      $Nombre = $Serie['nombre'];
      $Descripcion = $Serie['descripcion'];

      // Preparamos el enlace
      $Enlace = FN_PreparaEnlace ($Nombre, 0);

      // Mostramos el registro
      print "<LI><A CLASS=\"texto\" HREF=\"$Enlace\">$Nombre</A>.\n";
      print $Descripcion . "\n";
      }

    // Fin de la lista
    print "</UL>\n";
    }
  }

//------------------------------------------------
// Emite la estadística de fotos
function EmiteEstadistica()
  {
  // Consultamos cuántas series hay
  $TotalSerie = FN_TotalSerie();

  if ( $TotalSerie == 0 )
    { print "Todavía no hay estadística disponible\n"; }

  else
    {
    // Consultamos el resto de datos estadísticos
    $TotalFotos = FN_TotalFotos();
    $Media = FN_MediaFotos();

    // Mostramos el resultado
    print "Series: $TotalSerie. Fotos: <B>$TotalFotos</B>.\n";
    print "Media: $Media fotos por serie.";
    }
  }

?>
