<?php

//--------------------------------------------------------------
// Fichero:  listado.php
// Objetivo: Listar las fotos de una serie
// Fecha:    M.10.7.2012
// Autor:    Pedro Reina
// Licencia: Dominio público
//--------------------------------------------------------------

//------------------------------------------------
// Ficheros necesarios
//------------------------------------------------

require_once "config.php";
require_once "fn.php";

//------------------------------------------------
// Comienzo de la página
//------------------------------------------------

FN_EmiteDTD();

print "<HTML>\n";

//------------------------------------------------
// Llamada a la rutina principal
//------------------------------------------------

EmiteListado();

//------------------------------------------------
// Posibilidades para seguir
//------------------------------------------------

$Serie = $_GET['Serie'];
$Enlace = FN_PreparaEnlace ($Serie, 0);

print "<DIV CLASS=\"cuadro\">\n";
print "  <DIV CLASS=\"titulo3\">Posibilidades para seguir</DIV>\n";
print "  <DIV CLASS=\"contenido\">\n";
print "  <UL>\n";
print "  <LI><A CLASS=\"texto\" HREF=\"$Enlace\">";
print "  Volver al índice de la serie</A>\n";
print "  <LI><A CLASS=\"texto\" HREF=\".\">Volver a Fotos digitales</A>\n";
print "  <LI><A CLASS=\"texto\" HREF=\"/\">Volver a la página principal</A>\n";
print "  </UL>\n";
print "  </DIV>\n";
print "</DIV>\n";

//------------------------------------------------
// Final de la página
//------------------------------------------------

FN_EmiteValidadores();

print "</BODY>\n";
print "</HTML>\n";

//------------------------------------------------
// Funciones
//------------------------------------------------

// -----------------------------------------------
// Emite el listado de todas las fotos de la serie
function EmiteListado()
  {
  // La serie nos la pasan por la URL
  $Serie = $_GET['Serie'];

  // La cabecera del archivo HTML
  FN_EmiteCabecera ("Fotos digitales, listado de $Serie");

  // El logotipo
  FN_EmiteLogotipo();

  // La cabecera del listado
  print "<DIV CLASS=\"cuadro\">\n";
  print "<DIV CLASS=\"titulo2\">Fotos digitales, listado de la serie $Serie</DIV>\n";
  print "  <DIV CLASS=\"contenido\">\n";
  print "  <TABLE BORDER=\"1\" CELLPADDING=\"3\">\n";
  print "  <TR>\n";
  print "    <TD>Número</TD>\n";
  print "    <TD>Foto grande</TD>\n";
  print "    <TD>Tamaño</TD>\n";
  print "    <TD>Foto mediana</TD>\n";
  print "    <TD>Tamaño</TD>\n";
  print "  </TR>\n";

  // Montamos una relación con los nombres de las fotos
  // que hay en el directorio de la serie
  $Relacion = FN_Relacion ($Serie);

  // Cuántas fotos tiene la serie
  $Total = count ($Relacion);

  // Pasamos por cada foto
  for ( $i=0 ; $i<$Total ; $i++ )
    {
    // Número de orden
    $Num = $i + 1;

    // Nombre del archivo con la foto
    $NombreArchivo = $Relacion[$i];

    // Los nombres de las dos imágenes
    $NombreGrande = "$Serie/$NombreArchivo.jpg";
    $NombrePeque = "$Serie/reducidas/$NombreArchivo.jpeg";

    // Espacio que ocupan las dos imágenes
    $EspacioGrande = round (filesize ($NombreGrande) / 1024 / 1024, 2);
    $EspacioPeque = round (filesize ($NombrePeque) / 1024, 1);

    // Emitimos una fila con la información
    print "<TR>\n";
    print "  <TD>$Num</TD>\n";
    print "  <TD><A CLASS=\"texto\" HREF=\"$NombreGrande\">$NombreArchivo.jpg</A></TD>\n";
    print "  <TD>$EspacioGrande MB</TD>\n";
    print "  <TD><A CLASS=\"texto\" HREF=\"$NombrePeque\">$NombreArchivo.jpeg</A></TD>\n";
    print "  <TD>$EspacioPeque kB</TD>\n";
    print "</TR>\n";
    }

  // Terminamos el cuadro del listado
  print "    </TABLE>\n";
  print "    </DIV>\n";
  print "</DIV>\n";
  }

?>
